/*
 * $Header: /home/cvspublic/jakarta-slide/proposals/tamino/src/store/org/apache/slide/store/tamino/common/XDatastoreException.java,v 1.3 2004/07/30 06:51:52 ozeigermann Exp $
 * $Revision: 1.3 $
 * $Date: 2004/07/30 06:51:52 $
 *
 * ====================================================================
 *
 * Copyright 1999-2004 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.slide.store.tamino.common;

import org.apache.slide.util.XException;


/**
 ** This exception signals an error situation in the datastore (e.g. Tamino exception).
 **
 ** @author    peter.nevermann@softwareag.com
 ** @version   $Revision: 1.3 $
 **/
public class XDatastoreException extends XException {
    
    /**
     * Default constructor.
     */
    public XDatastoreException() {
    }
    
    /**
     * Construct object with a message.
     * @param msg  the message
     */
    public XDatastoreException(String msg) {
        super(msg);
    }
    
    /**
     * Construct object with a nested exceptioin.
     * @param e  the nested exception
     */
    public XDatastoreException (Exception e) {
        super(e);
    }
    
    /**
     * Construct object with a message and a nested exception.
     * @param msg  the message
     * @param e  the nested exception
     */
    public XDatastoreException (String msg, Exception e) {
        super(msg, e);
    }
}

