/*
 * $Header: /home/cvspublic/jakarta-slide/proposals/tamino/testsuite/junit/store/org/apache/slide/store/tamino/tools/stores/XDomainConfigTest.java,v 1.3 2004/07/30 06:52:19 ozeigermann Exp $
 * $Revision: 1.3 $
 * $Date: 2004/07/30 06:52:19 $
 *
 * ====================================================================
 *
 * Copyright 1999-2004 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.slide.store.tamino.tools.stores;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;
import org.apache.slide.util.XException;


/**
 ** Test for DGlobals.
 **
 ** @author    michael.hartmeier@softwareag.com
 ** @version   $Revision: 1.3 $
 **/
public class XDomainConfigTest extends TestCase {
    /**
     ** Construct a test case with the given test method name.
     **
     ** @pre   testMethodName != null
     ** @post  true
     **
     ** @param testMethodName   name of the test method that should be invoked
     **/
    public XDomainConfigTest( String testMethodName ) {
        super( testMethodName );
    }
    
    
    public void testEmpty() throws XException {
        XDomainConfig globals;
        
        globals = XDomainConfig.createEmpty();
        assertEquals("/history/foo", globals.getScopePattern(XDomainConfig.HISTORY_SCOPE_PATTERN).resolve("foo"));
        assertEquals("/workspace/foo", globals.getScopePattern(XDomainConfig.WORKSPACE_SCOPE_PATTERN).resolve("foo"));
        assertEquals("/workingresource/foo", globals.getScopePattern(XDomainConfig.WORKINGRESOURCE_SCOPE_PATTERN).resolve("foo"));
    }

    
    /**
     ** Start precisely this test suite with the commandline interface.
     **
     ** @pre   true
     ** @post  true
     **
     ** @param args   commandline options (none are evaluated)
     **/
    public static void main( String[] args ) {
        junit.textui.TestRunner.run( suite() );
    }
    
    
    public static Test suite() {
        return new TestSuite(  XDomainConfigTest.class );
    }
}

