/*
 * $Header: /home/cvspublic/jakarta-slide/proposals/tamino/testsuite/junit/store/org/apache/slide/store/tamino/tools/stores/XDomainTest.java,v 1.3 2004/07/30 06:52:19 ozeigermann Exp $
 * $Revision: 1.3 $
 * $Date: 2004/07/30 06:52:19 $
 *
 * ====================================================================
 *
 * Copyright 1999-2004 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.slide.store.tamino.tools.stores;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;
import org.apache.slide.util.XException;
import org.jdom.Element;


/**
 ** @author    michael.hartmeier@softwareag.com
 ** @version   $Revision: 1.3 $
 **/
public class XDomainTest extends TestCase {
    private XDomain domain;

    /**
     ** Construct a test case with the given test method name.
     **
     ** @pre   testMethodName != null
     ** @post  true
     **
     ** @param testMethodName   name of the test method that should be invoked
     **/
    public XDomainTest(String testMethodName) {
        super( testMethodName );
    }

    public void testEmpty() {
        domain = XDomain.create();
        check(domain);
    }

    public void testOne() {
        domain = XDomain.create();
        domain.addNamespace(new XNamespace("foo"));
        check(domain);
    }

    private XDomain check(XDomain orig) {
        Element xml;
        XDomain cloned;

        xml = orig.toXml();
        try {
            cloned = XDomain.fromXml(xml);
        } catch (XException e) {
            fail();
            return null; // dummy
        }
        assertEquals(orig.getNamespaces().size(), cloned.getNamespaces().size());
        assertEquals(orig.getConfig(), cloned.getConfig());
        return cloned;
    }


    /**
     ** Start precisely this test suite with the commandline interface.
     **
     ** @param args   commandline options (not used)
     **/
    public static void main( String[] args ) {
        junit.textui.TestRunner.run( suite() );
    }


    public static Test suite() {
        return new TestSuite(XDomainTest.class);
    }
}

