/*
 * $Header: /home/cvspublic/jakarta-slide/src/share/org/apache/slide/common/ServiceResetFailedException.java,v 1.6 2004/07/28 09:38:14 ib Exp $
 * $Revision: 1.6 $
 * $Date: 2004/07/28 09:38:14 $
 *
 * ====================================================================
 *
 * Copyright 1999-2002 The Apache Software Foundation 
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */ 

package org.apache.slide.common;

import org.apache.slide.util.Messages;

/**
 * Service reset failed.
 * 
 * @version $Revision: 1.6 $
 */
public class ServiceResetFailedException extends SlideException {
    
    
    // ----------------------------------------------------------- Constructors
    
    
    /**
     * Constructor.
     * 
     * @param service Service
     * @param cause Problem which occured during the reset attempt
     */
    public ServiceResetFailedException(Service service, String cause) {
        super(Messages.format(ServiceResetFailedException.class.getName(), 
                              service, cause));
    }
    
}
