/*
 * $Header: /home/cvspublic/jakarta-slide/src/stores/org/apache/slide/store/ojb/peer/LinkPeer.java,v 1.2 2005/01/23 13:57:27 cvillegas Exp $
 * $Revision: 1.2 $
 * $Date: 2005/01/23 13:57:27 $
 *
 * ====================================================================
 *
 * Copyright 1999-2002 The Apache Software Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */
package org.apache.slide.store.ojb.peer;

import java.io.Serializable;

/**
 * @ojb.class table="${table.prefix}LINKS"
 *
 */
public class LinkPeer implements Serializable {

    /**
     * @ojb.field column="URI_ID"
     *            primarykey="true"
     */
    private long uriId;
    
    /**
     * @ojb.field column="LINK_TO_ID"
     *            primarykey="true"
     */
    private long linkToId;
    
    /**
     * @ojb.reference foreignkey="uriId"
     */
    private UriPeer uri;
    
    /**
     * @ojb.reference foreignkey="linkToId"
     */
    private UriPeer linkToUri;
    
    /**
     * @return Returns the linkTo.
     */
    public UriPeer getLinkToUri() {
        return linkToUri;
    }
    /**
     * @param linkTo The linkTo to set.
     */
    public void setLinkToUri(UriPeer linkTo) {
        this.linkToUri = linkTo;
    }
    /**
     * @return Returns the linkToId.
     */
    public long getLinkToId() {
        return linkToId;
    }
    /**
     * @param linkToId The linkToId to set.
     */
    public void setLinkToId(long linkToId) {
        this.linkToId = linkToId;
    }
    /**
     * @return Returns the uri.
     */
    public UriPeer getUri() {
        return uri;
    }
    /**
     * @param uri The uri to set.
     */
    public void setUri(UriPeer uri) {
        this.uri = uri;
    }
    /**
     * @return Returns the uriId.
     */
    public long getUriId() {
        return uriId;
    }
    /**
     * @param uriId The uriId to set.
     */
    public void setUriId(long uriId) {
        this.uriId = uriId;
    }
}
