/*
 * $Header: /home/cvspublic/jakarta-slide/src/stores/org/apache/slide/store/ojb/peer/VersionLabelPeer.java,v 1.3 2005/01/23 13:57:27 cvillegas Exp $
 * $Revision: 1.3 $
 * $Date: 2005/01/23 13:57:27 $
 *
 * ====================================================================
 *
 * Copyright 1999-2002 The Apache Software Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */
package org.apache.slide.store.ojb.peer;

import java.io.Serializable;

/**
 * @ojb.class table="${table.prefix}VERSION_LABELS"
 *
 */
public class VersionLabelPeer implements Serializable {
    
    /**
     * @ojb.field column="VERSION_ID"
     *            primarykey="true"
     */
    private long versionId;

    /**
     * @ojb.field column="LABEL_ID"
     *            primarykey="true"
     */
    private long labelId;
    
    /**
     * @ojb.reference foreignkey="versionId"
     */
    private VersionHistoryPeer versionHistory;
    
    /**
     * @ojb.reference foreignkey="labelId"
     *                auto-retrieve="true"
     */
    private LabelPeer label;
    
    
    /**
     * @return Returns the label.
     */
    public LabelPeer getLabel() {
        return label;
    }
    /**
     * @param label The label to set.
     */
    public void setLabel(LabelPeer label) {
        this.label = label;
    }
    /**
     * @return Returns the labelId.
     */
    public long getLabelId() {
        return labelId;
    }
    /**
     * @param labelId The labelId to set.
     */
    public void setLabelId(long labelId) {
        this.labelId = labelId;
    }
    /**
     * @return Returns the versionHistory.
     */
    public VersionHistoryPeer getVersionHistory() {
        return versionHistory;
    }
    /**
     * @param versionHistory The versionHistory to set.
     */
    public void setVersionHistory(VersionHistoryPeer versionHistory) {
        this.versionHistory = versionHistory;
    }
    /**
     * @return Returns the versionId.
     */
    public long getVersionId() {
        return versionId;
    }
    /**
     * @param versionId The versionId to set.
     */
    public void setVersionId(long versionId) {
        this.versionId = versionId;
    }
}
