/*
 * $Header: /home/cvspublic/jakarta-slide/testsuite/testsuite/junit/src/org/apache/slide/testsuite/testtools/tprocessor/UpdateAssert.java,v 1.6 2004/07/28 09:31:55 ib Exp $
 * $Revision: 1.6 $
 * $Date: 2004/07/28 09:31:55 $
 *
 * ====================================================================
 *
 * The Apache Software License, Version 1.1
 *
 * Copyright (c) 1999-2002 The Apache Software Foundation.  All rights
 * reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution, if
 *    any, must include the following acknowlegement:
 *       "This product includes software developed by the
 *        Apache Software Foundation (http://www.apache.org/)."
 *    Alternately, this acknowlegement may appear in the software itself,
 *    if and wherever such third-party acknowlegements normally appear.
 *
 * 4. The names "The Jakarta Project", "Slide", and "Apache Software
 *    Foundation" must not be used to endorse or promote products derived
 *    from this software without prior written permission. For written
 *    permission, please contact apache@apache.org.
 *
 * 5. Products derived from this software may not be called "Apache"
 *    nor may "Apache" appear in their names without prior written
 *    permission of the Apache Group.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * This software consists of voluntary contributions made by many
 * individuals on behalf of the Apache Software Foundation.  For more
 * information on the Apache Software Foundation, please see
 * <http://www.apache.org/>.
 *
 * [Additional notices, if required by prior licensing conditions]
 *
 */

package org.apache.slide.testsuite.testtools.tprocessor;


// Slide
import java.util.List;
import org.apache.slide.testsuite.testtools.tutil.XConf;
import org.apache.commons.httpclient.util.URIUtil;
import org.apache.webdav.lib.methods.XMLResponseMethodBase;
import org.jdom.Element;




/**
 * Perform the necessary checks for the received and expected ACL body
 *
 * @version $Revision: 1.6 $
 */
public class UpdateAssert extends XMLResponseBodyAssert {


    /** constructor
     */
    public UpdateAssert(XMLResponseMethodBase method, Element elt, XConf xconf, XMLOutput xmlresult, List expectedResponseCodes){
        super(method, elt, xconf, xmlresult, expectedResponseCodes);
    }




    /**
     * checks if Expected Response and Response bodies are the same
     */
    public boolean assertResponseBody(){

//      if (method.getStatusCode() == 204 ||
//          method.getStatusCode() == 403 ||
//          method.getStatusCode() == 409 ||
//          method.getStatusCode() == 423 ||
//          method.getStatusCode() == 201 ||
//          method.getStatusCode() == 412  ){
//          return true;
//      }

        return super.assertResponseBody();
    }


    public boolean compareValues(String path, String name, String value1, String value2) {
        // ignore leading and trailing "/" in the href section and un-escape
        if (name.equals("href")){
            if (value1.endsWith("/")){
                value1 = value1.substring(0,value1.length()-1);
            }
            if (value2.endsWith("/")){
                value2 = value2.substring(0,value2.length()-1);
            }
            if (value1.startsWith("/")){
                value1 = value1.substring(1,value1.length());
            }
            if (value2.startsWith("/")){
                value2 = value2.substring(1,value2.length());
            }
            try {value1 = URIUtil.decode(value1, "UTF-8");} catch (Exception e) { }
            try {value2 = URIUtil.decode(value2, "UTF-8");} catch (Exception e) { }
        }
        return super.compareValues(path, name, value1, value2);
    }



}
